import type { BoxProps } from "@twilio-paste/box";
import type { TextColor } from "@twilio-paste/style-props";
import * as React from "react";
import type { Variants } from "./types";
/**
 * Helper to get the correct icon color for the dropdown chevron.
 *
 * @param variant
 * @param disabled
 * @param readOnly
 * @returns {TextColor} the icon color
 */
declare const getInputChevronIconColor: (variant?: Variants | undefined, disabled?: boolean | undefined, readOnly?: boolean | undefined) => TextColor;
export interface InputChevronWrapperProps {
    children: NonNullable<React.ReactNode>;
    element: BoxProps["element"];
}
declare const InputChevronWrapper: React.ForwardRefExoticComponent<InputChevronWrapperProps & {
    children?: React.ReactNode;
} & React.RefAttributes<HTMLDivElement>>;
export { InputChevronWrapper, getInputChevronIconColor };
//# sourceMappingURL=InputChevronWrapper.d.ts.map